%global commitId fa17bac54095a2e4c032e341100ab8d2fed02cfc

%global tower_version 4.3.6
%global tower_release 1
%global aap_version 2.3
%global controller_source_name automation-controller-%{commitId}
%global controller_assets_source_name controller-assets-49bae41565cce60b7b2aff27c37a84b713a3c92a
%global cryptography_source_name cryptography-36.0.2

%if 0%{?rhel} == 8
%global hardlink_pkg hardlink
%global hardlink_binary %{_sbindir}/hardlink
%global python3_pkgversion 39
%else
%global hardlink_pkg util-linux-core
%global hardlink_binary %{_bindir}/hardlink
%endif

%global distro_python_sitelib %(/usr/libexec/platform-python -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")

# Remove brp-python-bytecompile from os_install_post
%global __os_install_post /usr/lib/rpm/brp-compress \
  %{!?__debug_package:/usr/lib/rpm/brp-strip %{__strip}} \
  /usr/lib/rpm/brp-strip-static-archive %{__strip} \
  /usr/lib/rpm/brp-strip-comment-note %{__strip} %{__objdump} \
  /usr/lib/rpm/brp-python-hardlink

Name: automation-controller
Summary: REST api, server, plugins, UI, & CLI client for ansible
Version: %{tower_version}
Release: %{tower_release}%{?dist}
Source0: automation-controller-fa17bac54095a2e4c032e341100ab8d2fed02cfc.tar.gz
Source2: automation-controller.service
Source6: rsyslog.conf
Source7: controller-assets-49bae41565cce60b7b2aff27c37a84b713a3c92a.tar.gz
%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
Source8: %{cryptography_source_name}-vendor.tar.gz
Source91: system-certifi-5aa52ab91f9d579bfe52b5acf30ca799f1a563d9.tar.gz
Source92: django-radius-218428c20e885a300774dfaccc67ef10b2e976aa.tar.gz
%endif
Provides: automation-controller = %{version}-%{release}
Obsoletes: ansible-tower <= %{version}-%{release}

License: Commercial, see https://www.redhat.com/en/about/red-hat-end-user-license-agreements and https://www.redhat.com/en/about/licenses
URL:     https://github.com/ansible/awx

# Build Requirements
BuildArch: x86_64

BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-pip
BuildRequires: python%{python3_pkgversion}-rpm-macros
BuildRequires: python%{python3_pkgversion}-setuptools
BuildRequires: python%{python3_pkgversion}-wheel

BuildRequires: %{hardlink_pkg}
BuildRequires: sed
BuildRequires: git
BuildRequires: make
BuildRequires: gcc-c++
BuildRequires: bzip2
BuildRequires: postgresql-devel
BuildRequires: libffi-devel
BuildRequires: openssl-devel
%if 0%{?rhel} == 8
BuildRequires: openldap-devel
%else
BuildRequires: openldap-devel >= 2.6.2
%endif
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel
BuildRequires: xmlsec1-devel, xmlsec1-openssl-devel
BuildRequires: libtool-ltdl-devel
BuildRequires: swig
BuildRequires: libyaml-devel
BuildRequires: glibc-langpack-en
BuildRequires: cargo

BuildRequires: fontconfig
BuildRequires: gettext
BuildRequires: npm
BuildRequires: rsync

Requires: automation-controller-server = %{version}-%{release}
Requires: automation-controller-ui = %{version}-%{release}


%description
REST api, server, plugins, Web UI, & CLI client for ansible.

%package server
Summary: Automation Controller REST API
AutoReqProv: no
Obsoletes: ansible-tower-server <= %{version}-%{release}
Requires: automation-controller-venv-tower = %{version}-%{release}
Requires: ansible-automation-platform-common = %{aap_version}
Requires: nginx >= 1:1.18.0
Requires: crontabs
Requires: sshpass
Requires: supervisor >= 3.0
Requires: git
Requires: git-lfs
Requires: subscription-manager
Requires: subversion
Requires: postgresql
Requires: redis >= 6.0
Requires: sos
Requires: rsync
Requires: rsyslog >= 8.1911
Requires: xmlsec1
Requires: xmlsec1-openssl
Requires: crun
%if 0%{?rhel} == 8
Requires: openldap
%else
Requires: openldap >= 2.6.2
%endif

# SELinux requirements
Requires: python3-libsemanage

%description server
Automation Controller Server and REST API

%package ui
Summary: Automation Controller UI
Requires: automation-controller-server = %{version}-%{release}
Obsoletes: ansible-tower-ui <= %{version}-%{release}

%description ui
UI for Automation Controller

%package venv-tower
Summary: Automation Controller virtual environment
AutoReqProv: no
Obsoletes: ansible-tower-venv-ansible <= %{version}-%{release}
Obsoletes: ansible-tower-venv-tower <= %{version}-%{release}
Requires(pre): python%{python3_pkgversion}

# Python dependencies
Provides: bundled(python3dist(adal)) = 1.2.2
Provides: bundled(python3dist(aiohttp)) = 3.7.4
Provides: bundled(python3dist(aioredis)) = 1.3.1
Provides: bundled(python3dist(ansible-runner)) = 2.3.2
Provides: bundled(python3dist(ansiconv)) = 1.0.0
Provides: bundled(python3dist(asciichartpy)) = 1.5.25
Provides: bundled(python3dist(asgiref)) = 3.5.0
Provides: bundled(python3dist(asn1)) = 2.6.0
Provides: bundled(python3dist(async-timeout)) = 3.0.1
Provides: bundled(python3dist(attrs)) = 19.3.0
Provides: bundled(python3dist(autobahn)) = 20.12.3
Provides: bundled(python3dist(automat)) = 20.2.0
Provides: bundled(python3dist(azure-common)) = 1.1.25
Provides: bundled(python3dist(azure-keyvault)) = 1.1.0
Provides: bundled(python3dist(azure-nspkg)) = 3.0.2
Provides: bundled(python3dist(cachetools)) = 4.0.0
Provides: bundled(python3dist(cffi)) = 1.14.0
Provides: bundled(python3dist(channels)) = 2.4.0
Provides: bundled(python3dist(channels-redis)) = 3.1.0
Provides: bundled(python3dist(chardet)) = 3.0.4
Provides: bundled(python3dist(charset-normalizer)) = 2.0.7
Provides: bundled(python3dist(click)) = 7.1.2
Provides: bundled(python3dist(constantly)) = 15.1.0
Provides: bundled(python3dist(cryptography)) = 36.0.2
Provides: bundled(python3dist(cython)) = 0.29.22
Provides: bundled(python3dist(daphne)) = 2.4.1
Provides: bundled(python3dist(dataclasses)) = 0.6
Provides: bundled(python3dist(defusedxml)) = 0.6.0
Provides: bundled(python3dist(distro)) = 1.5.0
Provides: bundled(python3dist(django)) = 3.2.16
Provides: bundled(python3dist(django-auth-ldap)) = 4.0.0
Provides: bundled(python3dist(django-cors-headers)) = 3.7.0
Provides: bundled(python3dist(django-crum)) = 0.7.9
Provides: bundled(python3dist(django-extensions)) = 2.2.9
Provides: bundled(python3dist(django-guid)) = 3.2.1
Provides: bundled(python3dist(django-oauth-toolkit)) = 1.4.1
Provides: bundled(python3dist(django-pglocks)) = 1.0.4
Provides: bundled(python3dist(django-polymorphic)) = 3.1.0
Provides: bundled(python3dist(django-qsstats-magic)) = 1.1.0
Provides: bundled(python3dist(django-redis)) = 4.5.0
Provides: bundled(python3dist(django-solo)) = 2.0.0
Provides: bundled(python3dist(django-split-settings)) = 1.0.0
Provides: bundled(python3dist(django-taggit)) = 2.1.0
Provides: bundled(python3dist(djangorestframework)) = 3.13.1
Provides: bundled(python3dist(djangorestframework-yaml)) = 2.0.0
Provides: bundled(python3dist(docutils)) = 0.16
Provides: bundled(python3dist(ecdsa)) = 0.18.0
Provides: bundled(python3dist(enum-compat)) = 0.0.3
Provides: bundled(python3dist(filelock)) = 3.8.0
Provides: bundled(python3dist(future)) = 0.18.3
Provides: bundled(python3dist(gitdb)) = 4.0.2
Provides: bundled(python3dist(gitpython)) = 3.1.30
Provides: bundled(python3dist(google-auth)) = 1.35.0
Provides: bundled(python3dist(hiredis)) = 1.0.1
Provides: bundled(python3dist(hyperlink)) = 20.0.1
Provides: bundled(python3dist(idna)) = 2.9
Provides: bundled(python3dist(incremental)) = 21.3.0
Provides: bundled(python3dist(irc)) = 18.0.0
Provides: bundled(python3dist(isodate)) = 0.6.1
Provides: bundled(python3dist(jaraco-classes)) = 3.1.0
Provides: bundled(python3dist(jaraco-collections)) = 3.0.0
Provides: bundled(python3dist(jaraco-functools)) = 3.0.0
Provides: bundled(python3dist(jaraco-logging)) = 3.0.0
Provides: bundled(python3dist(jaraco-stream)) = 3.0.0
Provides: bundled(python3dist(jaraco-text)) = 3.2.0
Provides: bundled(python3dist(jinja2)) = 3.0.3
Provides: bundled(python3dist(json-log-formatter)) = 0.3.0
Provides: bundled(python3dist(jsonschema)) = 3.2.0
Provides: bundled(python3dist(kubernetes)) = 23.3.0
Provides: bundled(python3dist(lockfile)) = 0.12.2
Provides: bundled(python3dist(lxml)) = 4.7.0
Provides: bundled(python3dist(markdown)) = 3.2.1
Provides: bundled(python3dist(markupsafe)) = 2.0.1
Provides: bundled(python3dist(more-itertools)) = 8.2.0
Provides: bundled(python3dist(msgpack)) = 1.0.0
Provides: bundled(python3dist(msrest)) = 0.6.11
Provides: bundled(python3dist(msrestazure)) = 0.6.3
Provides: bundled(python3dist(multidict)) = 4.7.5
Provides: bundled(python3dist(netaddr)) = 0.8.0
Provides: bundled(python3dist(oauthlib)) = 3.2.0
Provides: bundled(python3dist(openshift)) = 0.13.1
Provides: bundled(python3dist(packaging)) = 21.3
Provides: bundled(python3dist(pexpect)) = 4.7.0
Provides: bundled(python3dist(pkgconfig)) = 1.5.5
Provides: bundled(python3dist(prometheus-client)) = 0.7.1
Provides: bundled(python3dist(psutil)) = 5.8.0
Provides: bundled(python3dist(psycopg2)) = 2.8.4
Provides: bundled(python3dist(ptyprocess)) = 0.6.0
Provides: bundled(python3dist(pyasn1)) = 0.4.8
Provides: bundled(python3dist(pyasn1-modules)) = 0.2.8
Provides: bundled(python3dist(pycparser)) = 2.20
Provides: bundled(python3dist(pygerduty)) = 0.38.2
Provides: bundled(python3dist(pyjwt)) = 2.4.0
Provides: bundled(python3dist(pyopenssl)) = 19.1.0
Provides: bundled(python3dist(pyparsing)) = 2.4.6
Provides: bundled(python3dist(pyrad)) = 2.4
Provides: bundled(python3dist(pyrsistent)) = 0.15.7
Provides: bundled(python3dist(python-daemon)) = 2.2.4
Provides: bundled(python3dist(python-dateutil)) = 2.8.1
Provides: bundled(python3dist(python-dsv-sdk)) = 0.0.1
Provides: bundled(python3dist(python-jose)) = 3.3.0
Provides: bundled(python3dist(python-ldap)) = 3.4.0
Provides: bundled(python3dist(python-string-utils)) = 1.0.0
Provides: bundled(python3dist(python-tss-sdk)) = 1.0.0
Provides: bundled(python3dist(python3-openid)) = 3.1.0
Provides: bundled(python3dist(python3-saml)) = 1.13.0
Provides: bundled(python3dist(pytz)) = 2021.3
Provides: bundled(python3dist(pyyaml)) = 5.4.1
Provides: bundled(python3dist(receptorctl)) = 1.2.3
Provides: bundled(python3dist(redis)) = 3.4.1
Provides: bundled(python3dist(requests)) = 2.26.0
Provides: bundled(python3dist(requests-oauthlib)) = 1.3.1
Provides: bundled(python3dist(rsa)) = 4.7.2
Provides: bundled(python3dist(schedule)) = 0.6.0
Provides: bundled(python3dist(semantic-version)) = 2.9.0
Provides: bundled(python3dist(service-identity)) = 18.1.0
Provides: bundled(python3dist(setuptools-rust)) = 1.2.0
Provides: bundled(python3dist(setuptools-scm)) = 6.4.2
Provides: bundled(python3dist(six)) = 1.14.0
Provides: bundled(python3dist(slack-sdk)) = 3.11.2
Provides: bundled(python3dist(smmap)) = 3.0.1
Provides: bundled(python3dist(social-auth-app-django)) = 5.0.0
Provides: bundled(python3dist(social-auth-core)) = 4.3.0
Provides: bundled(python3dist(sqlparse)) = 0.4.2
Provides: bundled(python3dist(tacacs-plus)) = 1.0
Provides: bundled(python3dist(tempora)) = 2.1.0
Provides: bundled(python3dist(tomli)) = 2.0.1
Provides: bundled(python3dist(twilio)) = 7.9.1
Provides: bundled(python3dist(twisted)) = 22.4.0
Provides: bundled(python3dist(txaio)) = 20.12.1
Provides: bundled(python3dist(typing-extensions)) = 3.10.0.2
Provides: bundled(python3dist(urllib3)) = 1.26.5
Provides: bundled(python3dist(uwsgi)) = 2.0.18
Provides: bundled(python3dist(uwsgitop)) = 0.11
Provides: bundled(python3dist(websocket-client)) = 0.57.0
Provides: bundled(python3dist(wheel)) = 0.38.4
Provides: bundled(python3dist(xmlsec)) = 1.3.12
Provides: bundled(python3dist(yarl)) = 1.4.2
Provides: bundled(python3dist(zope-interface)) = 5.0.0
Provides: bundled(python3dist(pip)) = 21.2.4
Provides: bundled(python3dist(setuptools)) = 58.2.0
# JS dependencies
Provides: bundled(npm(@babel/code-frame)) = 7.16.7
Provides: bundled(npm(@babel/generator)) = 7.16.8
Provides: bundled(npm(@babel/generator/source-map)) = 0.5.7
Provides: bundled(npm(@babel/helper-annotate-as-pure)) = 7.16.7
Provides: bundled(npm(@babel/helper-environment-visitor)) = 7.16.7
Provides: bundled(npm(@babel/helper-function-name)) = 7.16.7
Provides: bundled(npm(@babel/helper-get-function-arity)) = 7.16.7
Provides: bundled(npm(@babel/helper-hoist-variables)) = 7.16.7
Provides: bundled(npm(@babel/helper-module-imports)) = 7.16.7
Provides: bundled(npm(@babel/helper-split-export-declaration)) = 7.16.7
Provides: bundled(npm(@babel/helper-validator-identifier)) = 7.16.7
Provides: bundled(npm(@babel/highlight)) = 7.16.10
Provides: bundled(npm(@babel/parser)) = 7.16.10
Provides: bundled(npm(@babel/runtime)) = 7.16.7
Provides: bundled(npm(@babel/template)) = 7.16.7
Provides: bundled(npm(@babel/traverse)) = 7.16.10
Provides: bundled(npm(@babel/types)) = 7.16.8
Provides: bundled(npm(@codemirror/autocomplete)) = 6.0.2
Provides: bundled(npm(@codemirror/commands)) = 6.0.1
Provides: bundled(npm(@codemirror/language)) = 6.2.0
Provides: bundled(npm(@codemirror/lint)) = 6.0.0
Provides: bundled(npm(@codemirror/search)) = 6.0.0
Provides: bundled(npm(@codemirror/state)) = 6.1.0
Provides: bundled(npm(@codemirror/view)) = 6.0.2
Provides: bundled(npm(@emotion/is-prop-valid)) = 1.1.2
Provides: bundled(npm(@emotion/memoize)) = 0.7.5
Provides: bundled(npm(@emotion/stylis)) = 0.8.5
Provides: bundled(npm(@emotion/unitless)) = 0.7.5
Provides: bundled(npm(@lezer/common)) = 1.0.0
Provides: bundled(npm(@lezer/highlight)) = 1.0.0
Provides: bundled(npm(@lezer/lr)) = 1.1.0
Provides: bundled(npm(@lingui/core)) = 3.14.0
Provides: bundled(npm(@lingui/react)) = 3.14.0
Provides: bundled(npm(@patternfly/patternfly)) = 4.210.2
Provides: bundled(npm(@patternfly/react-core)) = 4.231.8
Provides: bundled(npm(@patternfly/react-core/@patternfly/react-icons)) = 4.82.8
Provides: bundled(npm(@patternfly/react-core/tslib)) = 2.3.1
Provides: bundled(npm(@patternfly/react-icons)) = 4.75.1
Provides: bundled(npm(@patternfly/react-styles)) = 4.81.8
Provides: bundled(npm(@patternfly/react-table)) = 4.100.8
Provides: bundled(npm(@patternfly/react-table/@patternfly/react-icons)) = 4.82.8
Provides: bundled(npm(@patternfly/react-table/tslib)) = 2.4.0
Provides: bundled(npm(@patternfly/react-tokens)) = 4.83.8
Provides: bundled(npm(ace-builds)) = 1.10.1
Provides: bundled(npm(ansi-regex)) = 6.0.1
Provides: bundled(npm(ansi-styles)) = 3.2.1
Provides: bundled(npm(ansi-to-html)) = 0.7.2
Provides: bundled(npm(argparse)) = 2.0.1
Provides: bundled(npm(asynckit)) = 0.4.0
Provides: bundled(npm(attr-accept)) = 1.1.3
Provides: bundled(npm(axios)) = 0.27.2
Provides: bundled(npm(axios/form-data)) = 4.0.0
Provides: bundled(npm(babel-plugin-styled-components)) = 1.12.0
Provides: bundled(npm(babel-plugin-syntax-jsx)) = 6.18.0
Provides: bundled(npm(camelize)) = 1.0.0
Provides: bundled(npm(chalk)) = 2.4.2
Provides: bundled(npm(clsx)) = 1.1.1
Provides: bundled(npm(codemirror)) = 6.0.1
Provides: bundled(npm(color-convert)) = 1.9.3
Provides: bundled(npm(color-name)) = 1.1.3
Provides: bundled(npm(combined-stream)) = 1.0.8
Provides: bundled(npm(core-js)) = 2.6.12
Provides: bundled(npm(crelt)) = 1.0.5
Provides: bundled(npm(css-color-keywords)) = 1.0.0
Provides: bundled(npm(css-to-react-native)) = 3.0.0
Provides: bundled(npm(csstype)) = 3.0.8
Provides: bundled(npm(d3)) = 7.4.4
Provides: bundled(npm(d3-array)) = 3.1.1
Provides: bundled(npm(d3-axis)) = 3.0.0
Provides: bundled(npm(d3-brush)) = 3.0.0
Provides: bundled(npm(d3-chord)) = 3.0.1
Provides: bundled(npm(d3-color)) = 3.0.1
Provides: bundled(npm(d3-contour)) = 3.0.1
Provides: bundled(npm(d3-delaunay)) = 6.0.2
Provides: bundled(npm(d3-dispatch)) = 3.0.1
Provides: bundled(npm(d3-drag)) = 3.0.0
Provides: bundled(npm(d3-dsv)) = 3.0.1
Provides: bundled(npm(d3-dsv/commander)) = 7.2.0
Provides: bundled(npm(d3-dsv/iconv-lite)) = 0.6.3
Provides: bundled(npm(d3-ease)) = 3.0.1
Provides: bundled(npm(d3-fetch)) = 3.0.1
Provides: bundled(npm(d3-force)) = 3.0.0
Provides: bundled(npm(d3-format)) = 3.0.1
Provides: bundled(npm(d3-geo)) = 3.0.1
Provides: bundled(npm(d3-hierarchy)) = 3.0.1
Provides: bundled(npm(d3-interpolate)) = 3.0.1
Provides: bundled(npm(d3-path)) = 3.0.1
Provides: bundled(npm(d3-polygon)) = 3.0.1
Provides: bundled(npm(d3-quadtree)) = 3.0.1
Provides: bundled(npm(d3-random)) = 3.0.1
Provides: bundled(npm(d3-scale)) = 4.0.2
Provides: bundled(npm(d3-scale-chromatic)) = 3.0.0
Provides: bundled(npm(d3-selection)) = 3.0.0
Provides: bundled(npm(d3-shape)) = 3.0.1
Provides: bundled(npm(d3-time)) = 3.0.0
Provides: bundled(npm(d3-time-format)) = 4.0.0
Provides: bundled(npm(d3-timer)) = 3.0.1
Provides: bundled(npm(d3-transition)) = 3.0.1
Provides: bundled(npm(d3-zoom)) = 3.0.0
Provides: bundled(npm(dagre)) = 0.8.5
Provides: bundled(npm(debug)) = 4.3.3
Provides: bundled(npm(deepmerge)) = 2.2.1
Provides: bundled(npm(delaunator)) = 5.0.0
Provides: bundled(npm(delayed-stream)) = 1.0.0
Provides: bundled(npm(diff-match-patch)) = 1.0.5
Provides: bundled(npm(dom-helpers)) = 5.2.1
Provides: bundled(npm(dompurify)) = 2.4.0
Provides: bundled(npm(entities)) = 2.2.0
Provides: bundled(npm(escape-string-regexp)) = 1.0.5
Provides: bundled(npm(file-selector)) = 0.1.19
Provides: bundled(npm(file-selector/tslib)) = 2.2.0
Provides: bundled(npm(focus-trap)) = 6.9.2
Provides: bundled(npm(follow-redirects)) = 1.15.1
Provides: bundled(npm(formik)) = 2.2.9
Provides: bundled(npm(globals)) = 11.12.0
Provides: bundled(npm(graphlib)) = 2.1.8
Provides: bundled(npm(has-ansi)) = 5.0.1
Provides: bundled(npm(has-flag)) = 3.0.0
Provides: bundled(npm(history)) = 4.10.1
Provides: bundled(npm(hoist-non-react-statics)) = 3.3.2
Provides: bundled(npm(html-entities)) = 2.3.2
Provides: bundled(npm(internmap)) = 2.0.3
Provides: bundled(npm(isarray)) = 0.0.1
Provides: bundled(npm(js-tokens)) = 4.0.0
Provides: bundled(npm(js-yaml)) = 4.1.0
Provides: bundled(npm(jsesc)) = 2.5.2
Provides: bundled(npm(lodash)) = 4.17.21
Provides: bundled(npm(lodash-es)) = 4.17.21
Provides: bundled(npm(lodash.get)) = 4.4.2
Provides: bundled(npm(lodash.isequal)) = 4.5.0
Provides: bundled(npm(loose-envify)) = 1.4.0
Provides: bundled(npm(luxon)) = 3.0.3
Provides: bundled(npm(make-plural)) = 6.2.2
Provides: bundled(npm(messageformat-parser)) = 4.1.3
Provides: bundled(npm(mime-db)) = 1.51.0
Provides: bundled(npm(mime-types)) = 2.1.34
Provides: bundled(npm(mini-create-react-context)) = 0.4.1
Provides: bundled(npm(ms)) = 2.1.2
Provides: bundled(npm(object-assign)) = 4.1.1
Provides: bundled(npm(path-to-regexp)) = 1.8.0
Provides: bundled(npm(popper.js)) = 1.16.1
Provides: bundled(npm(postcss-value-parser)) = 4.2.0
Provides: bundled(npm(prop-types)) = 15.8.1
Provides: bundled(npm(prop-types-extra)) = 1.1.1
Provides: bundled(npm(react)) = 17.0.2
Provides: bundled(npm(react-ace)) = 10.1.0
Provides: bundled(npm(react-dom)) = 17.0.2
Provides: bundled(npm(react-dropzone)) = 9.0.0
Provides: bundled(npm(react-error-boundary)) = 3.1.4
Provides: bundled(npm(react-fast-compare)) = 2.0.4
Provides: bundled(npm(react-is)) = 16.13.1
Provides: bundled(npm(react-lifecycles-compat)) = 3.0.4
Provides: bundled(npm(react-router)) = 5.3.3
Provides: bundled(npm(react-router-dom)) = 5.3.3
Provides: bundled(npm(react-virtualized)) = 9.22.3
Provides: bundled(npm(regenerator-runtime)) = 0.13.9
Provides: bundled(npm(resolve-pathname)) = 3.0.0
Provides: bundled(npm(robust-predicates)) = 3.0.1
Provides: bundled(npm(rrule)) = 2.7.1
Provides: bundled(npm(rrule/tslib)) = 2.4.0
Provides: bundled(npm(rw)) = 1.3.3
Provides: bundled(npm(safer-buffer)) = 2.1.2
Provides: bundled(npm(scheduler)) = 0.20.2
Provides: bundled(npm(shallowequal)) = 1.1.0
Provides: bundled(npm(style-mod)) = 4.0.0
Provides: bundled(npm(styled-components)) = 5.3.5
Provides: bundled(npm(supports-color)) = 5.5.0
Provides: bundled(npm(tabbable)) = 5.3.3
Provides: bundled(npm(tiny-invariant)) = 1.2.0
Provides: bundled(npm(tiny-warning)) = 1.0.3
Provides: bundled(npm(tippy.js)) = 5.1.2
Provides: bundled(npm(to-fast-properties)) = 2.0.0
Provides: bundled(npm(tslib)) = 1.13.0
Provides: bundled(npm(value-equal)) = 1.0.1
Provides: bundled(npm(w3c-keyname)) = 2.2.4
Provides: bundled(npm(warning)) = 4.0.3

%description venv-tower
Automation Controller virtual environment

%package cli
Summary: Package for Automation Controller CLI
AutoReqProv: no
Obsoletes: ansible-tower-cli <= %{version}-%{release}
Requires: python%{python3_pkgversion}
Requires: python%{python3_pkgversion}-setuptools
Requires: python%{python3_pkgversion}-requests
Requires: python%{python3_pkgversion}-pyyaml

%description cli
Package for Automation Controller CLI

%prep
%setup -q -n %{controller_source_name}

tar -C %{_builddir} -xf %{SOURCE7}

%build
# Disable debuginfo packages
%define _enable_debug_package 0
%define debug_package %{nil}

# TODO: can be changed to cp? check file attributes in tar
rsync -avz %{_builddir}/%{controller_assets_source_name}/awx/ui/client/assets/ awx/ui/public/static/media/

echo %{version} > VERSION
echo %{version} > awxkit/VERSION

npm config set registry https://repository.engineering.redhat.com/nexus/repository/registry.npmjs.org/
npm config set strict-ssl false

%{__python3} -m pip config set global.index https://repository.engineering.redhat.com/nexus/repository/pypi.org/pypi
%{__python3} -m pip config set global.index_url https://repository.engineering.redhat.com/nexus/repository/pypi.org/simple
%{__python3} -m pip config set global.trusted-host repository.engineering.redhat.com

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
mkdir requirements/vendor
cp %{SOURCE91} requirements/vendor/
cp %{SOURCE92} requirements/vendor/

cat > requirements/requirements_local.txt<<EOF
./requirements/vendor/system-certifi-5aa52ab91f9d579bfe52b5acf30ca799f1a563d9.tar.gz
./requirements/vendor/django-radius-218428c20e885a300774dfaccc67ef10b2e976aa.tar.gz
EOF

pip_version=`grep pip== requirements/requirements.txt |cut -d'=' -f3`
%{__python3} -m pip install --user pip==$pip_version

~/.local/bin/pip%{python3_version} download \
        --no-deps \
        --platform any \
        --requirement=requirements/requirements.txt \
        --dest=requirements/vendor \
        --exists-action=i | grep --line-buffered .

# Add rust crates vendor file to cryptography
tar -xf %{SOURCE8}
gzip -d requirements/vendor/%{cryptography_source_name}.tar.gz
tar -rf requirements/vendor/%{cryptography_source_name}.tar %{cryptography_source_name}
gzip requirements/vendor/%{cryptography_source_name}.tar

%endif

npm install --prefix %{_builddir} node@14.15.1
export PATH=%{_builddir}/node_modules/node/bin:$PATH

make ui-release

pushd awxkit
  %{__python3} setup.py sdist
  cp dist/awxkit-%{version}.tar.gz %{_builddir}/%{name}-cli-%{version}-%{release}.tar.gz
popd


%install

export LANG=en_US.UTF-8 LANGUAGE=en_US.en LC_ALL=en_US.UTF-8

mkdir -p %{buildroot}/var/lib/awx/rsyslog
mkdir -p %{buildroot}/var/lib/awx/rsyslog/conf.d
cp %{SOURCE6} %{buildroot}/var/lib/awx/rsyslog/rsyslog.conf

export PYTHON=python%{python3_version}

# Create folder for the virtualenvs
export VENV_BASE=venv
mkdir -p $VENV_BASE

# Fix m2crypto builds (details at http://pkgs.fedoraproject.org/cgit/m2crypto.git/tree/m2crypto.spec)
export SWIG_FEATURES="-cpperraswarn"

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
export PIP_OPTIONS="--find-links=requirements/vendor --no-index"

cat >> setup.cfg <<EOF
[easy_install]
index_url = ''
find_links = file://$PWD/requirements/vendor/
EOF

cat >> ~/.pydistutils.cfg <<EOF
[easy_install]
index_url = ''
find_links = file://$PWD/requirements/vendor/
EOF
%endif

# Install the awxkit package
%{__python3} -m pip install ../%{name}-cli-%{version}-%{release}.tar.gz --root %{buildroot} --no-deps

export CFLAGS="-DXMLSEC_NO_SIZE_T"
# Install the Tower venv and requirements
%{__make} requirements_awx

# TODO
rm -f awx/devonly.py

# Move site-packages to the buildroot
mkdir -p %{buildroot}/var/lib/awx/venv/awx/lib/python%{python3_version}
mv venv/awx/lib/python%{python3_version}/site-packages %{buildroot}/var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages

# Move bin files
mkdir -p %{buildroot}/var/lib/awx/venv/awx/bin
rm -f %{buildroot}/var/lib/awx/venv/awx/bin/pip*
cp -rp venv/awx/bin/pip* %{buildroot}/var/lib/awx/venv/awx/bin/
mv venv/awx/bin/uwsgi %{buildroot}/var/lib/awx/venv/awx/bin/uwsgi
mv venv/awx/bin/uwsgitop %{buildroot}/var/lib/awx/venv/awx/bin/uwsgitop
mv venv/awx/bin/daphne %{buildroot}/var/lib/awx/venv/awx/bin/daphne
mv venv/awx/bin/ansible-runner %{buildroot}/var/lib/awx/venv/awx/bin/ansible-runner
mv venv/awx/bin/receptorctl %{buildroot}/var/lib/awx/venv/awx/bin/receptorctl

# Install to the buildroot (non virtualenv)
mkdir -p %{buildroot}/rpm-tmp

%{__python3} -m pip install \
  --no-compile \
  --no-deps \
  --progress-bar off \
  --no-index \
  --no-cache-dir \
  --no-build-isolation \
  --no-warn-script-location \
  --root=%{buildroot}/rpm-tmp \
  .

# Move files from rpm-tmp folder to the appropriate base folders
mv %{buildroot}/rpm-tmp/usr/lib/python%{python3_version}/site-packages/* %{buildroot}/var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages

mkdir -p %{buildroot}/usr/bin
mv %{buildroot}/rpm-tmp/usr/bin/awx-manage %{buildroot}/usr/bin
mv tools/scripts/automation-controller-service tools/scripts/failure-event-handler tools/scripts/awx-python %{buildroot}/usr/bin

# Replace python interpreter shebang to known destination system paths
PYTHON_INTERPRETER='#!/var/lib/awx/venv/awx/bin/python'
for executable in  %{buildroot}/usr/bin/awx-manage \
  %{buildroot}/var/lib/awx/venv/awx/bin/pip* \
  %{buildroot}/var/lib/awx/venv/awx/bin/daphne \
  %{buildroot}/var/lib/awx/venv/awx/bin/ansible-runner \
  %{buildroot}/var/lib/awx/venv/awx/bin/receptorctl
do
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" $executable
done

# Symlinks to old tower-python and tower-manage executables
ln -s /usr/bin/awx-manage %{buildroot}/%{_bindir}/tower-manage
ln -s /usr/bin/awx-python %{buildroot}/%{_bindir}/tower-python

mkdir -p %{buildroot}/usr/share/sosreport/sos/plugins
mv tools/sosreport/controller.py %{buildroot}/usr/share/sosreport/sos/plugins

mkdir -p %{buildroot}/usr/share/doc/ansible-tower
mv docs/licenses/* %{buildroot}/usr/share/doc/ansible-tower

mkdir -p %{buildroot}/lib/systemd/system
install -m 644 %{SOURCE2} %{buildroot}/lib/systemd/system

mkdir -p %{buildroot}/usr/share/awx
mv tools/scripts/request_tower_configuration.sh tools/scripts/request_tower_configuration.ps1 %{buildroot}/usr/share/awx

rm -rf %{buildroot}/rpm-tmp

# Create other needed folders
install -d %{buildroot}/%{_sysconfdir}/tower/
install -d -m 0750 %{buildroot}/var/log/tower
install -d -m 0750 %{buildroot}/var/lib/awx/job_status
install -d %{buildroot}/%{_datadir}/awx
install -d -m 2775 %{buildroot}/var/run/tower

%clean
rm -rf %{buildroot}

%preun
automation-controller-service stop

%pre server
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
# Remove old links
rm -f %{distro_python_sitelib}/sos/plugins/tower.py >/dev/null 2>&1 || :
rm -f %{distro_python_sitelib}/sos/report/plugins/tower.py >/dev/null 2>&1 || :

%post server
# Generate or reuse key file
if [ ! -f /etc/tower/SECRET_KEY ]; then
%{__python3} -c 'import base64, os; f = open("/etc/tower/SECRET_KEY", "w"); f.write(base64.encodebytes(os.urandom(33)).decode().rstrip()); f.close()'
fi
chown root:awx /etc/tower/SECRET_KEY
chmod 640 /etc/tower/SECRET_KEY

# Create sosreport symlinks
ln -s /usr/share/sosreport/sos/plugins/controller.py  %{distro_python_sitelib}/sos/plugins/ || :
ln -s /usr/share/sosreport/sos/plugins/controller.py  %{distro_python_sitelib}/sos/report/plugins/ || :

# allow needed nginx access
/sbin/restorecon -R /var/lib/awx/venv /var/lib/awx/job_status /var/run/tower
chown -R nginx:nginx /var/run/tower || :
if [ $1 -eq 1 ] ; then
        # Initial installation
        systemctl --no-reload preset automation-controller.service >/dev/null 2>&1 || :
fi

%preun server
if [ $1 -eq 0 ] ; then
        # Package removal, not upgrade
        systemctl --no-reload disable --now automation-controller.service >/dev/null 2>&1 || :
fi

%postun server
sed -i -e '/^# START AWX/,/^# END AWX/d' /etc/supervisord.conf
# Remove custom policy
if [ $1 -eq 0 ] ; then
    # Remove sosreport symlinks
    rm -f %{distro_python_sitelib}/sos/plugins/controller.py || :
    rm -f %{distro_python_sitelib}/sos/report/plugins/controller.py || :
fi

%pre venv-tower
systemctl stop supervisord >/dev/null 2>&1 || :
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
%{__python3} -m venv --clear /var/lib/awx/venv/awx

%files
%defattr(-,root,root)

%files server
%exclude /var/lib/awx/venv
%defattr(-,root,root)
%doc %{_datadir}/doc/ansible-tower
%{_bindir}/awx-manage
%{_bindir}/awx-python
%{_bindir}/tower-manage
%{_bindir}/tower-python
%{_bindir}/automation-controller-service
%{_bindir}/failure-event-handler
/lib/systemd/system/automation-controller.service
%attr(2775,nginx,nginx) /var/run/tower
%dir %attr(0755,awx,awx) /var/lib/awx
%dir %attr(0755,awx,awx) /var/lib/awx/rsyslog
%attr(0750,awx,awx) /var/log/tower
/var/lib/awx/[^j]*
%attr(0750,awx,awx) /var/lib/awx/rsyslog/rsyslog.conf
%attr(0750,awx,awx) /var/lib/awx/job_status
%{_datadir}/awx/
%{_datadir}/sosreport/sos/plugins/controller.py*
%config(noreplace) %attr(-,root,awx) %{_sysconfdir}/tower

%files ui
%defattr(-,root,root)
/var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages/awx/static

%files venv-tower
%exclude /var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages/awx/static
%exclude /var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages/awx/ui/static
%defattr(-,root,root)
/var/lib/awx/venv/awx

%files cli
%exclude /usr/bin/akit
%{_bindir}/awx
%{python3_sitelib}/awxkit*

%changelog
* Mon Mar 06 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.6-1
- Automation Controller 4.3.6 release

* Wed Feb 01 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.5-1
- Automation Controller 4.3.5 release

* Tue Jan 10 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.4-1
- Automation Controller 4.3.4 release

* Thu Jan 05 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.3-1
- Automation Controller 4.3.3 release

* Wed Dec 14 2022 Satoe Imaishi <simaishi@redhat.com> - 4.3.2-1
- Automation Controller 4.3.2 release

* Wed Dec 07 2022 Satoe Imaishi <simaishi@redhat.com> - 4.3.1-1
- Automation Controller 4.3.1 release

* Fri Nov 11 2022 Satoe Imaishi <simaishi@redhat.com> - 4.3.0-2
- Automation Controller 4.3.0 release

* Tue Aug 30 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.1-1
- Automation Controller 4.2.1 release

* Wed Jul 20 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.0-6
- Add python3-libsemanage as a dependency

* Wed Jul 13 2022 Dimitri Savineau <dsavinea@redhat.com> - 4.2.0-5
- systemd: add dependency on receptor.service

* Mon Jun 27 2022 Hao Liu <haoli@redhat.com> - 4.2.0-4
- Update Ansible Runner version to 2.2.1

* Mon Jun 13 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.0-3
- Enable Korean locale

* Wed May 18 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.0-2
- Automation Controller 4.2.0 release
